const jsx = require('babel-plugin-syntax-jsx');

module.exports = function({ Plugin, types: t }) {
    const visitor = {};
    visitor.ExportDefaultDeclaration = function(path) {
        const filename = this.file.opts.filename;
        if (path.node.declaration.type !== 'ArrowFunctionExpression') return;
      
        const arrowFunction = path.node.declaration;

        const properties = arrowFunction.params[0].properties.map(function(prop) {
            return prop.key;
        });

        const returnStatement = t.returnStatement(t.parenthesizedExpression(arrowFunction.body));

        const declares = properties.map(function(p) {
            return t.variableDeclarator(
                p,
                t.memberExpression(t.memberExpression(t.identifier('this'), t.identifier('props')), p)
            );
        });
        const destructProps = t.variableDeclaration('const', declares);

        const renderBody = t.blockStatement([destructProps, returnStatement]);
        const renderMethod = t.classMethod('method', t.identifier('render'), [], renderBody);
        const classBody = t.classBody([renderMethod]);
        const classDeclaration = t.classDeclaration(
            t.identifier('__Clazz__'),
            t.identifier('require("react").Component'),
            classBody,
            []
        );

        path.replaceWith(t.exportDefaultDeclaration(classDeclaration));
    };

    return {
        inherits: jsx,
        visitor
    };
};
